<style include="shared-styles">
        :host {
          display: block;
  
          padding: 10px;
        }
        .flex-horizontal-wrap {
          @apply --layout-horizontal;
          @apply --layout-wrap;
        }
        .flex-main {
          width: 60%;
          min-width: 400px 
        }
        .flex-second {
          @apply --layout-flex;
          min-width: 100px;
          margin-left: 30px
        }
        .flex-equal {
          @apply --layout-flex;
          min-width: 200px;
          margin-left: 30px
        }
        .flex-sticky {
          position: sticky;
          top: 0px;
        }
        .p-indent {
          text-indent: -20px
        }
        .public {
          background-color: #dcb5a2;
        }
        .private {
          background-color: #a9d18e;
        }
      </style>   
  <div class="card">
      <span style="float:right"> <img src="images/icon/apple-icon-144x144.png" alt=""></span>
      
      <p><b>Blockchain</b> is an amazing technology but it is either global and public or secure and restricted. </p>
      <p>
      Ethereum is firstly known for being the first worldwide public blockchain enabling programmatic collaborations over smart contracts. <br>
      But when companies need to transact they <b>want their business to remain confidential and secure</b>. <br>
      So they turn away from public blockchains and either trust a centralised platform or organise private blockchain network. </p>
      
      <h2>Ethereum Privacy</h2> <p>is an initiative to resolve that problem by enabling companies to harvest the benefits of a worldwide public blockchain infrastructure while trading safely.</p>
      <p>Let's say Alice wants Bob to lend him money. Bob has a number of conditions and they both agree to it and they want to enter into an agreement. <br>Bob and Alice have a business relationship and know each other public keys. <br>However, they want their transactions to remain confidential to any other parties and they do not want to invest into a dedicated infrastructure to transact.</p>
      <p>Alice and Bob choose to leverage the reliability, autonomy, persistance of the public Ethereum blockchain, adding <b>"Ethereum Privacy"</b> on top of it to record their agreement into a smart contract that only they can see. It will allow them to collect each other signatures. In case of conflict, any party can reveal to a court a proof stored in the public, unalterable blockchain.</p>
  </div>
  <div class="card">
    <span class="circle">1</span>
    <b>Private transactions flow</b>
    <p>End user connects to an Ethereum standalone node he/she trusts (a privacy node pnA) that in turn interacts with a standard Ethereum blockchain node (a public node) participating to the public consensus.</p>
    <p>Sending a private transaction to a partner that is trusting a different Privacy Node (pnC) requires the following steps:</p>
    <div class="container flex-horizontal-wrap">
      <div class="flex-main"><img class="flex-sticky" src="images/transaction-flows.png" width="100%"></div>
      <div class="flex-second">
          <p class="p-indent">
          1.	The client prepares a standard Ethereum transactions and sends it to a Privacy Node (pnA) it trusts and specify to which other Privacy Nodes (pnC) this transaction should be shared with</p>
          <p class="p-indent">
          2.	The pnA node retrieves the public keys of all the target nodes (pnC) from a PKI and add its own public key </p>
          <p class="p-indent">
          3.	The pnA node signs the transaction data with its private rsa key, generates a symmetric aes 256 key and encrypt the signed transaction. The symmetric key is encrypted with the public key for each of the target nodes (pnA, pnC)</p>
          <p class="p-indent">
          4.	The symmetric encrypted transaction and all asymmetric encrypted keys are published into the PrivateTransactions smart contract in the public blockchain </p>
          <p class="p-indent">
          5.	The public transactions are transmitted in the P2P network and eventually mined in the public blockchain</p>
          <p class="p-indent">
          6.	All Privacy Nodes (and anyone else) see the new transaction (with only encrypted data) in the public blockchain's logs and pick it up</p>
          <p class="p-indent">
          7.	Each Privacy Node attempts to decrypt the symmetric key with its own private key. In case of success (i.e. the transaction is intended for it) it can proceed, else the transaction is ignored. </p>
          <p class="p-indent">
          8.	The sending Privacy Node's public key is checked against the PKI to ensure it is known and trusted</p>
          <p class="p-indent">
          9.	With the symmetric key the Privacy Node decrypts the transaction data</p>
          <p class="p-indent">
          10.	With the decrypted transaction, the Privacy Node injects it in the private, local blockchain  </p>      
      </div>
    </div>
  </div>
  <paper-dialog id="privateBlockDialog" style="left:0px; top:120px; position:fixed">
      <h2>Private block [[privateBlockNumberDisplay]] (raw response) </h2>
      <web3-eth-get-block-by-number id="web3EthGetBlockByNumber" hidden="" result-as-text="{{blockByNumber}}" node-url="{{privateUrlNode}}" method="eth_getBlockByNumber" block-tag="[[privateBlockNumber]]" private=""></web3-eth-get-block-by-number>
      <paper-dialog-scrollable><json-formatter value="[[blockByNumber]]"/></paper-dialog-scrollable>
      <div class="buttons">
        <paper-button dialog-dismiss>Close</paper-button>
      </div>
  </paper-dialog>
  <div class="card">
    <web3-block-number hidden="" block-number="{{ropstenBlock}}" api-key="anykey"></web3-block-number>
    <web3-json-rpc hidden="" auto result="{{privateBlockNumber}}" node-url="{{privateUrlNode}}" method="eth_blockNumber" private="" auto-refresh="5000"></web3-json-rpc>
    <span class="circle">2</span>
      <b>Here you have access to a live deployment of the prototype</b>
    <p>This web page is connected to an infrastructure of privacy nodes that talks to Ethereum Ropsten testnet</p>
    <p>The current block in <span class="public">the public blockchain</span> is <new-tab-link href="${config.etherscan_root}/block/[[ropstenBlock]]" display="[[ropstenBlock]]"></new-tab-link> </p>
    <p>The current block in <span class="private">the privacy node</span> is <new-tab-link on-click="openBlockByNumberDialog" display="[[privateBlockNumberDisplay]]"/>  </p>
    <p>The privacy node interacts with the public blockchain via a smart contract <new-tab-link href="${config.etherscan_root}/address/${config.private_tx_smart_contract}#code" display="PrivateTxStorage"></new-tab-link>
       that allows storing encrypted transactions and notyfying participants of the symetric encryption key.</p>
  </div>   
  <paper-dialog id="smartContractCode" style="left:0px; top:120px; position:fixed">
      <h2>Solidity code for the private smart contract</h2>
      <p>A very simple key value smart contract</p>
      <paper-dialog-scrollable>
      <code style="white-space: pre" class="language-javascript">
  pragma solidity ^0.5.1;
  
  contract KeyValueStore {
    // structure of the value owned by the issuer
    struct OwnedValue {
      address owner;
      string value;
    }
    // key mapped to the structure
    mapping(string => OwnedValue) private values;
    // event generated every time the value of a key is set
    event newKeySet(string key, address owner, bool created);
    
    function getValue(string memory key) public view returns (string memory) {
      return values[key].value;
    }
    // Only unused key can be set and given an owner
    // Only the initial owner of a key can update its value
    function setValue(string memory key, string memory value) public {
      if( values[key].owner == address(0x0) ) {
        emit newKeySet(key, msg.sender, true);
        values[key] = OwnedValue(msg.sender, value);
      } else if( values[key].owner == msg.sender ) {
        emit newKeySet(key, msg.sender, false);
        values[key].value = value;
      } else revert("Not allowed");
    }   
  }
  </code>
      </paper-dialog-scrollable>
      <div class="buttons">
        <paper-button dialog-dismiss>Close</paper-button>
      </div>
  </paper-dialog>
  <div class="card">
    <span class="circle">3</span><b>Playing with a simple private smart contract</b>
    <p>1- Select the privacy node this page connects to and from which to submit transactions</p>
    <paper-dropdown-menu id="privacyNodeSelector" label="select the privacy Node" style="width:25em" value="{{selectedPrivacyNode}}" >
        <paper-listbox slot="dropdown-content" selected="0" >
            <dom-repeat items="[[privacyNodes]]"> 
              <template>
                <paper-item label="[[item.name]]">[[item.name]] </paper-item>
              </template>
            </dom-repeat>
        </paper-listbox>
    </paper-dropdown-menu> 
    <p>2- Then, you need to select the parties (privacy nodes) you wish interact with via a smart contract</p>
    <div class="vertical-section-container centered">
        <dom-repeat items="[[privacyNodes]]"> 
            <template>
                <dom-if if="[[!_isSelected(item)]]">
                  <template><paper-checkbox checked on-change="nodeSelectionChanged" id="[[item.name]]">[[item.name]] </paper-checkbox><br></template>
                </dom-if>
              </template>
          </dom-repeat>
    </div>
    <p>3- Then, select the predefined wallet to transact with (or use MetaMask)</p>
    <paper-dropdown-menu id="accountSelector" label="select a wallet" style="width:25em" value="{{selectedLocalAccount}}" >
    <paper-listbox slot="dropdown-content" selected="0" >
      <dom-repeat items="{{localAccounts}}">
        <template>
            <paper-item label="{{item}}">{{item}}</paper-item>
        </template>
      </dom-repeat>
      <paper-item label="metamask">use metamask account</paper-item>
    </paper-listbox>
    </paper-dropdown-menu> 
    <dom-if if="[[isMetamaskSelected]]"><template><p>Metamask wallet: [[usedLocalAccount]] </p></template></dom-if>
  </paper-dropdown-menu> 
    <p>4- Then, create an instance of the smart contract</p>
    <key-value-store-contract 
      id="keyValueStore" account="[[usedLocalAccount]]" address="{{keyValueStoreAddress}}" 
      url="[[privateUrlNode]]" selected-nodes="[[selectedTargetNodesArray]]" on-new-event="_NewEventKeyValue"
      on-start-transaction="kvsStartTx" on-complete-transaction="kvsEndTx">
    </key-value-store-contract>
    <div class="vertical-section-container centered">
      <p><paper-button raised on-click="openSmartContractCodeDialog">view</paper-button>a simple smart contract that manages key/value pairs with ownership of keys</p>
      <dom-if if="[[shouldDisplayCreateKeyValueStore]]">
        <template><p><paper-button id="btCreateSmartContract" raised on-click="createSmartContract">Create</paper-button>an instance of the smart contract on all the selected privacy node(s); or set the address of the smart contract below</p></template>
      </dom-if>
      <dom-if if="[[shouldDisplayKeyValueStoreAddressInput]]">
        <template><paper-input id="inputSmartContratAddress" label="Enter the smart contract address here" value="{{keyValueStoreAddress}}" style="width:25em" auto-validate pattern="0x[0-9a-fA-F]{40}" error-message="Ethereum address expected"></paper-input></template>
      </dom-if>
      <p>[[miningMessage]]</p>
    </div>
    <dom-if if="[[!shouldDisplayKeyValueStoreActions]]">
      <template><p>5- Following steps will be displayed when you have a valid smart contract address</p></template>
    </dom-if>
    <dom-if id="myDomIf" if="[[shouldDisplayKeyValueStoreActions]]">
      <template>
        <p>5- Set key/value pair in the smart contract</p>
        <div class="container flex-horizontal-wrap">
            <div class="flex-equal">
                <paper-input id="inputKey" label="Enter a key" value="{{keyName}}" style="width:25em" ></paper-input>
            </div>
            <div class="flex-equal">
                <paper-input id="inputValue" label="Enter the key value" value="{{keyValue}}" style="width:25em" ></paper-input>
            </div>
        <dom-if if="[[shouldDisplaySetKeyValueInput]]">
          <template><paper-button id="btSetKeyPair" raised on-click="setKeyPair">Set</paper-button></template>
        </dom-if>
        </div>
        <p>[[miningMessage2]]</p>
        
        <key-value-pair-list new-event="[[keyPairLastEvent]]" address="[[keyValueStoreAddress]]"></key-value-pair-list>
      </template>  
    </dom-if>
    <p>See the transactions below in the public node as sent to the ropsten network and in the private node</p>
</div>
  <web3-json-rpc id="rpcGetTxProof" hidden="" result="{{privateTxProof}}" node-url="{{privateUrlNode}}" method="admin_getTransactionProof" private="" on-result="onRpcTxProofResponse"></web3-json-rpc>
    
  <paper-dialog id="privateTxDialog" style="left:0px; top:120px; position:fixed">
      <h2>Private transaction [[privateTx.hash]] (raw response) </h2>
      <div><paper-button id="btShowTxProof" raised on-click="showTxProof">See proof</paper-button></div>
      <paper-dialog-scrollable><json-formatter value="[[privateTx]]"/></paper-dialog-scrollable>
      <div class="buttons">
        <paper-button dialog-dismiss>Close</paper-button>
      </div>
  </paper-dialog>

  <paper-dialog id="privateTxProofDialog" style="left:0px; top:120px; position:fixed">
    <h2>Private transaction proof [[privateTx.hash]] </h2>
    <paper-dialog-scrollable><json-formatter value="[[privateTxProof]]"/></paper-dialog-scrollable>
    <div class="buttons">
      <paper-button dialog-dismiss>Close</paper-button>
    </div>
  </paper-dialog>

  
  <div class="card">
    <span class="circle">4</span><b>Viewing the transactions</b>
    <div class="container flex-horizontal-wrap">
      <div class="flex-equal">
        <p>Private transactions</p>
        <private-transaction-list id="privateTxList" private-url-node="{{privateUrlNode}}" on-click="openPrivateTxDetails"/>
      </div>
      <div class="flex-equal">
          <p>PrivateTxStorage public transactions (<new-tab-link href="${config.etherscan_root}/address/${config.private_tx_smart_contract}" display="see more ..."></new-tab-link>)</p>
          <etherscan-transaction-list last-block-number="[[ropstenBlock]]"/>
      </div>
    </div>
  </div>

  <div class="card">
      <span class="circle">5</span><b>Want to know more? Contact and Contributions</b>
      <h4>What's inside the box?</h4>
      <ul type="circle">
        <li>First, a Privacy node is a NodeJs process that exposes an http(s) web3 json rpc compatible API to which any standard client can safely connect to (Metamask, Geth console, Remix ...)</li>
        <li>The node handles a <new-tab-link href="https://gitlab.com/guenoledc-perso/offchainprivatetx/ethereum-standalone-node" display="Standalone standard Ethereum VM"></new-tab-link> implemented using the <new-tab-link href="https://github.com/ethereumjs/" display="EthereumJs libraries "></new-tab-link> with a local storage. This module itself can be usefull for having a local Ethereum dev environment for testing smart contracts (a bit like Ganache)</li>
        <li>A very simple <new-tab-link href="https://gitlab.com/guenoledc-perso/offchainprivatetx/pki-interface" display="PKI implementation"></new-tab-link> to store public keys and associate them to a name</li>
        <li>A <new-tab-link href="https://gitlab.com/guenoledc-perso/offchainprivatetx/ethereum-standalone-node/blob/master/lib/keystore/index.js" display="keystore"></new-tab-link> that handles Ethereum wallets in a same way as a geth client would do with the additionnal capacity to sign transactions without revealing the private key.</li>
        <li>A Web3 <new-tab-link href="https://gitlab.com/guenoledc-perso/offchainprivatetx/ethereum-privacy/blob/master/lib/rpc/websocket-provider.js" display="websocket provider"></new-tab-link> that handles well inside a Web3Js version 0.20.x and that recreates filters lost after reconnection</li>
        <li>Config to connect to the selected public blockchain (could also be a private blockchain on which some transactions shoudl remain confidential) and deployment of the PrivateTxStorage smart contract</li>
        <li>And, the <new-tab-link href="https://gitlab.com/guenoledc-perso/offchainprivatetx/core-crypto-privacy/blob/master/core/core.js" display="core of the cryptographic algorithm"></new-tab-link> that enables communicating privately inside a public environment</li>
      </ul>
      <h4>Known limitations</h4>
      <ul type="circle">
        <li>Private smart contracts execute in a different state space of the Ethereum virtual machine, hence a private smart contract cannot access public smart contracts. However, the private node enable accessing both the private and the public node via its Web3 json-rpc API</li>
        <li>Privacy nodes interact with the public blockchain using a unique wallet making it recognizable. Work is being done to build anonymous wallet framework</li>
        <li>Private smart contracts cannot handle crypto assets or token if all parties are not always informed of asset movement since privacy nodes can only replicate transactions they are a party of</li>
      </ul>
      <h4>On the roadmap</h4>
      Assuming that good feedbacks are collected on the work done, and that their is a business interest, the items in the backlog are
      <ul type="circle">
        <li>Package a "Get Started Tutorial" to have anyone deploy a privacy node (clean repo, docker image, ...)</li>
        <li>Implement a more professional PKI implementation using X509 certificates and that can connect to PKI enterprise software</li>
        <li>Implement a public to private smart contract replication to make some public smart contract accessible to the private smart contract</li>
        <li>Implement an anonymous wallet mechanism for privacy nodes to create wallets and fund them via a faucet without revealing their identity</li>
        <li>Make a production grade version and approach Kaleido, Consensys ...</li>
      </ul>
      <span style="float:right"> <img src="images/icon/apple-icon-144x144.png" alt=""></span>
      <h4>Contributions</h4>
      <p>This prototype is the result of research done by <new-tab-link href="https://www.linkedin.com/in/guenoledecadoudal/" display="Guénolé de Cadoudal "></new-tab-link> and is intended to be open-sourced.</p>
      <p>Get in touch via <new-tab-link href="https://www.linkedin.com/messaging/compose/?recipient=guenoledecadoudal" display="linkedIN messages "></new-tab-link> or via <a href="mailto:guenoledc@yahoo.fr?subject=Ethereum Privacy Project">guenoledc@yahoo.fr</a> </p>
      <p>Leave feedbacks directly on <new-tab-link href="https://gitlab.com/guenoledc-perso/offchainprivatetx/website/issues/new" display="gitlab issues"></new-tab-link> 
        or by sending emails to <a href="mailto:incoming+guenoledc-perso-offchainprivatetx-website-11341400-issue-@incoming.gitlab.com">gitlab issues</a></p>
      <p>Git repo is on <new-tab-link href="https://gitlab.com/guenoledc-perso/offchainprivatetx" display="gitlab.com"></new-tab-link> and is open for clone, fork and issue submission. Anyone whishing to contribute can be added to the repo by asking</p>
      <p>You can also <new-tab-link href="https://etherdonation.com/d?to=${config.my_donation_account}" display="donate ETH"></new-tab-link> to contribute to the development efforts</p>
      <p>If you think my profile and capacity are of some benefit to your organisation, let me know if I can contribute.</p>
    </div>